/** questo programma legge un numero intero positivo in base 10 e ne da` la rappresentazione
 *  in binario puro.
 */

#include <stdio.h>
#include <stdlib.h>

int main()
{
	unsigned int b10, quoz, resto, i;
	char bin[64]; /* conterra` la rappresentazione del numero binario */

	printf("Inserisci il numero in base 10: ");
	scanf("%u", &b10);

	i = 0;
	quoz = b10;
	
	/* nota: >> operatore bit a bit shifta a destra il suo operando sinistro di 
	 * un numero di bit pari al valore del loro operando destro, che deve essere
	 * positivo.
	 * Eseguendo lo shift a destra di un operando unsigned, i bit rimasti liberi
	 * vengono sempre posti a zero. Se la quantita` e` invece signed, il risultato
	 * dipende dalla macchina (shift aritmetico - tutti uguali al bit di segno - o
	 * shift logico - tutti posti a zero).
	 * Il problema non si pone sull'operatore di shift a sinistra (<<), che pone
	 * sempre a zero le posizioni liberate.
	 */
	while(quoz) /* contiamo quante volte serve dividere il numero in base 10 */
	{
		quoz = quoz >> 1; /* lo stesso che quoz / 2 */
		i++;
	}
	/* i contiene il numero di cifre necessarie a rappresentare il numero in binario.
	 * Si sarebbe potuto evitare il ciclo sopra e invertire il vettore di caratteri
	 * bin alla fine: ricordiamo infatti che i resti vanno presi in ordine inverso.
	 */
	bin[i] = '\0'; /* terminiamo la stringa con il '\0' */
	/* ripartiamo con quoz inizializzato al numero di partenza */
	quoz = b10;
	while(quoz > 0)
	{
		resto = quoz % 2;
		quoz = quoz >> 1;
		/* ecco il vettore dei resti, che vengono inseriti gia` all'incontrario in bin */
		bin[--i] = resto + '0'; 
	}
	/* fatto! */
	printf("%d in base 2 vale %s\n", b10, bin);
	
	return EXIT_SUCCESS;
}

