#include <stdio.h>
#include <stdlib.h>

#define MAXROWS 40
#define MAXCOLS 128 /* the number of standard ASCII characters */

int main()
{
	int ch, r, c;
	int matrix[MAXROWS][MAXCOLS]; /* number of standard ASCII characters */

	/* initialize the matrix. It will contain MAXROWS * MAXCOLS white spaces */
	for(r = 0; r < MAXROWS; r++)
		for(c = 0; c < MAXCOLS; c++)
			matrix[r][c] = ' ';

	while( (ch = getchar()) != '\n')
	{
		r = 0;
		/* 1. skip elements which already have a '*' set on the column corresponding to the 
		 *    character ch and the row r.
		 */
		while(r < MAXROWS -1 && matrix[r][ch]  != ' ') /* why MAXROWS - 1 ?? */
			r++;

		/* store a '*' symbol on the first row which is not a space in the column ch */
		matrix[r][ch] = '*';
	}
		
	putchar('\n'); /* to separate the first line of the result from the text previously typed */

	/* print the matrix, starting from the top row to have an histogram with the bottom as baseline */
	for(r = MAXROWS - 1; r >= 0; r--)
	{
		for(c = 0; c < MAXCOLS; c++)
		{
			/* do not print empty columns */
			if(matrix[0][c] != ' ') 	
				putchar(matrix[r][c]);
		}
		putchar('\n');
	}

	for(c = 0; c < MAXCOLS; c++)
		if(matrix[0][c] != ' ')
			putchar(c);
	putchar('\n');
}

