#include <stdio.h>
#include <string.h>

int main()
{
	/* dichiaro pmessage come puntatore a caratteri */
	char *pmessage;
	/* assegno a pmessage un puntatore al vettore di caratteri */
	pmessage = "Un messaggio";
	printf("pmessage: \"%s\"\n", pmessage);

	/* !! NON VIENE FATTA ALCUNA COPIA DELLA STRINGA dall'istruzione di assegnazione sopra:
	 * la copia avviene solo tra puntatori. pmessage e` un puntatore inizializzato in modo
	 * che punti a una stringa COSTANTE: esso puo` essere modificato affinche` punti altrove,
	 * vedi (1), ma non si puo` modificare il contenuto della stringa.
	 */
	// Errato!
	//	pmessage[0] = 'a';
	//	printf("pmessage modificato: \"%s\"\n", pmessage); /* qui potrebbe non arrivarci... */
	
	/* amessage ora e` un vettore sufficientemente grande da contenere la sequenza di caratteri
	 * e il '\0' che lo inizializzano.
	 * I singoli caratteri all'interno di amessage possono cambiare, ma amessage si riferisce 
	 * sempre alla stessa zona di memoria.
	 */
	char amessage[] = "Un altro messaggio"; /* dichiarazione e inizializzazione di amessage */
	printf("amessage: \"%s\"\n", amessage);

	amessage[0] = 'I';
	printf("amessage modificato: \"%s\" (lunghezza %d)\n", amessage, strlen(amessage));

	// ERRATO: 
	/* perdo il puntatore alla zona precedente e assegno di nuovo una stringa costante al
	 * puntatore amessage. Questo potrebbe non essere quello che desidero veramente, visto
	 * che l'operatore '=' tra stringhe non esegue una copia "profonda" dei singoli caratteri,
	 * ma copia solo il puntatore alla zona di memoria occupata dal primo elemento.
	 */
	// amessage = "Hola a todos";

	strcpy(amessage, "Hola a todos");
	printf("amessage modificato con strcpy(): \"%s\" (lunghezza %d)\n", amessage, strlen(amessage));

	char *pmesg = "Hola a toda la clase de informatica!";
	printf("faccio seconda modifica a amessage con strcpy() - lunghezza %d:\n", strlen(pmesg));
	// strcpy(amessage, pmesg);
	// printf("\"%s\"\n", amessage);

	/* vedi man strncpy */
	strncpy(amessage, pmesg, strlen("Un altro messaggio"));
	printf("Ultima modifica con strncpy(): \"%s\"\n", amessage);
	
	return 0;

}



